Unit ip04e_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure ip04e(var Y :Array of Extended; var Y1 :Array of Extended;
                var Y2 :Array of Extended; var Y12 :Array of Extended;
                X1L :Extended; X1U :Extended; X2L :Extended; X2U :Extended;
                X1 :Extended; X2 :Extended; var AY :Extended;
                var AY1 :Extended; var AY2 :Extended; var AY12 :Extended;
                var C :Array of Extended);

implementation

procedure ip04e(var Y :Array of Extended; var Y1 :Array of Extended;
                var Y2 :Array of Extended; var Y12 :Array of Extended;
                X1L :Extended; X1U :Extended; X2L :Extended; X2U :Extended;
                X1 :Extended; X2 :Extended; var AY :Extended;
                var AY1 :Extended; var AY2 :Extended; var AY12 :Extended;
                var C :Array of Extended);
var
I,J,K,L :Integer;
D1,D2,D1D2,XX,T,U,SY,SY1,SY2,SY12 :Extended;
CL :Array [0..15] of Extended;
X :Array [0..15] of Extended;
const
ZERO :Extended = 0.0e0;
WT :Array [0..255] of Extended = ( 1.0e0,0.0e0,-3.0e0,2.0e0,0.e0,0.e0,0.e0,0.e0,
-3.0e0,0.0e0,9.0e0,-6.0e0,2.0e0,0.0e0,-6.0e0,
4.0e0,0.e0,0.e0,0.e0,0.e0,0.e0,0.e0,0.e0,0.e0,
3.0e0,0.0e0,-9.0e0,6.0e0,-2.0e0,0.0e0,6.0e0,
-4.0e0,0.e0,0.e0,0.e0,0.e0,0.e0,0.e0,0.e0,0.e0,
0.e0,0.e0,9.0e0,-6.0e0,0.e0,0.e0,-6.0e0,4.0e0,
0.e0,0.e0,3.0e0,-2.0e0,0.e0,0.e0,0.e0,0.e0,0.e0,
0.e0,-9.0e0,6.0e0,0.e0,0.e0,6.0e0,-4.0e0,0.e0,
0.e0,0.e0,0.e0,1.0e0,0.0e0,-3.0e0,2.0e0,-2.0e0,
0.0e0,6.0e0,-4.0e0,1.0e0,0.0e0,-3.0e0,2.0e0,0.e0,
0.e0,0.e0,0.e0,0.e0,0.e0,0.e0,0.e0,-1.0e0,0.0e0,
3.0e0,-2.0e0,1.0e0,0.0e0,-3.0e0,2.0e0,0.e0,0.e0,
0.e0,0.e0,0.e0,0.e0,0.e0,0.e0,0.e0,0.e0,-3.0e0,
2.0e0,0.e0,0.e0,3.0e0,-2.0e0,0.e0,0.e0,0.e0,0.e0,
0.e0,0.e0,3.0e0,-2.0e0,0.e0,0.e0,-6.0e0,4.0e0,
0.e0,0.e0,3.0e0,-2.0e0,0.0e0,1.0e0,-2.0e0,1.0e0,
0.e0,0.e0,0.e0,0.e0,0.e0,-3.0e0,6.0e0,-3.0e0,
0.0e0,2.0e0,-4.0e0,2.0e0,0.e0,0.e0,0.e0,0.e0,0.e0,
0.e0,0.e0,0.e0,0.e0,3.0e0,-6.0e0,3.0e0,0.0e0,
-2.0e0,4.0e0,-2.0e0,0.e0,0.e0,0.e0,0.e0,0.e0,0.e0,
0.e0,0.e0,0.e0,0.e0,-3.0e0,3.0e0,0.e0,0.e0,2.0e0,
-2.0e0,0.e0,0.e0,-1.0e0,1.0e0,0.e0,0.e0,0.e0,0.e0,
0.e0,0.e0,3.0e0,-3.0e0,0.e0,0.e0,-2.0e0,2.0e0,
0.e0,0.e0,0.e0,0.e0,0.e0,1.0e0,-2.0e0,1.0e0,0.0e0,
-2.0e0,4.0e0,-2.0e0,0.0e0,1.0e0,-2.0e0,1.0e0,0.e0,
0.e0,0.e0,0.e0,0.e0,0.e0,0.e0,0.e0,0.e0,-1.0e0,
2.0e0,-1.0e0,0.0e0,1.0e0,-2.0e0,1.0e0,0.e0,0.e0,
0.e0,0.e0,0.e0,0.e0,0.e0,0.e0,0.e0,0.e0,1.0e0,
-1.0e0,0.e0,0.e0,-1.0e0,1.0e0,0.e0,0.e0,0.e0,0.e0,
0.e0,0.e0,-1.0e0,1.0e0,0.e0,0.e0,2.0e0,-2.0e0,
0.e0,0.e0,-1.0e0,1.0e0 );
label
_10,_20,_30,_40,_50,_60,_70;
begin
D1 := X1U-X1L;
D2 := X2U-X2L;
D1D2 := D1*D2;
for I:=1 to 4 do
 begin
  X[I-1] := Y[I-1];
  X[I+3] := Y1[I-1]*D1;
  X[I+7] := Y2[I-1]*D2;
  X[I+11] := Y12[I-1]*D1D2;
_10:
 end;
for I:=1 to 16 do
 begin
  XX := ZERO;
  for K:=1 to 16 do
   begin
    XX := XX+WT[(I-1)+(K-1)*16]*X[K-1];
_20:
   end;
  CL[I-1] := XX;
_30:
 end;
L := 0;
for I:=1 to 4 do
 begin
  for J:=1 to 4 do
   begin
    L := L+1;
    C[(I-1)+(J-1)*4] := CL[L-1];
_40:
   end;
_50:
 end;
T := (X1-X1L)/D1;
U := (X2-X2L)/D2;
AY := ZERO;
AY1 := ZERO;
AY2 := ZERO;
AY12 := ZERO;
for I:=1 to 4 do
 begin
  SY := ZERO;
  SY1 := ZERO;
  SY2 := ZERO;
  SY12 := ZERO;
  for J:=1 to 4 do
   begin
    SY := SY+C[(I-1)+(J-1)*4]*Power(U,J-1);
    SY1 := SY1+C[(I-1)+(J-1)*4]*Power(U,J-1);
    SY2 := SY2+(J-1)*C[(I-1)+(J-1)*4]*Power(U,J-2);
    SY12 := SY12+(J-1)*C[(I-1)+(J-1)*4]*Power(U,J-2);
_60:
   end;
  AY := AY+Power(T,I-1)*SY;
  AY1 := AY1+(I-1)*Power(T,I-2)*SY1;
  AY2 := AY2+Power(T,I-1)*SY2;
  AY12 := AY12+(I-1)*Power(T,I-2)*SY12;
_70:
 end;
AY1 := AY1/D1;
AY2 := AY2/D2;
AY12 := AY12/D1D2;
end;

end.
